--- old/usr/src/lib/libmd/amd64/Makefile	Mon Oct  7 19:17:15 2013
+++ new/usr/src/lib/libmd/amd64/Makefile	Mon Oct  7 19:17:15 2013
@@ -20,12 +20,13 @@
 #
 #
 # Copyright (c) 2006, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2013 Saso Kiselkov. All rights reserved.
 #
 
 LIBRARY =	libmd.a
 VERS =		.1
 
-OBJECTS =	md4.o md5.o sha1.o sha2.o
+OBJECTS =	edonr.o md4.o md5.o sha1.o sha2.o skein.o skein_block.o
 
 include		$(SRC)/lib/Makefile.lib
 include		$(SRC)/lib/Makefile.rootfs
--- old/usr/src/lib/libmd/common/mapfile-vers	Mon Oct  7 19:17:15 2013
+++ new/usr/src/lib/libmd/common/mapfile-vers	Mon Oct  7 19:17:15 2013
@@ -20,6 +20,7 @@
 #
 #
 # Copyright (c) 2006, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2013 Saso Kiselkov. All rights reserved.
 #
 
 #
@@ -75,6 +76,28 @@
 	SHA512Final	{ FLAGS = NODYNSORT };
 	SHA512Init;
 	SHA512Update	{ FLAGS = NODYNSORT };
+	Skein1024_Final;
+	Skein1024_Final_Pad;
+	Skein1024_Init;
+	Skein1024_InitExt;
+	Skein1024_Output;
+	Skein1024_Update;
+	Skein_256_Final;
+	Skein_256_Final_Pad;
+	Skein_256_Init;
+	Skein_256_InitExt;
+	Skein_256_Output;
+	Skein_256_Update;
+	Skein_512_Final;
+	Skein_512_Final_Pad;
+	Skein_512_Init;
+	Skein_512_InitExt;
+	Skein_512_Output;
+	Skein_512_Update;
+	EdonRFinal;
+	EdonRHash;
+	EdonRInit;
+	EdonRUpdate;
     local:
 	*;
 };
--- /dev/null	Mon Oct  7 19:17:15 2013
+++ new/usr/src/lib/libmd/common/skein.h	Mon Oct  7 19:17:15 2013
@@ -0,0 +1,31 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2013 Saso Kiselkov.  All rights reserved.
+ */
+
+#ifndef _SKEIN_H
+#define	_SKEIN_H
+
+#include <sys/skein.h>
+
+#endif	/* _SKEIN_H */
--- old/usr/src/lib/libmd/i386/Makefile	Mon Oct  7 19:17:15 2013
+++ new/usr/src/lib/libmd/i386/Makefile	Mon Oct  7 19:17:15 2013
@@ -21,12 +21,13 @@
 
 #
 # Copyright (c) 2006, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2013 Saso Kiselkov. All rights reserved.
 #
 
 LIBRARY =	libmd.a
 VERS =		.1
 
-OBJECTS =	md4.o md5.o sha1.o sha2.o
+OBJECTS =	edonr.o md4.o md5.o sha1.o sha2.o skein.o skein_block.o
 
 include		$(SRC)/lib/Makefile.lib
 include		$(SRC)/lib/Makefile.rootfs
--- old/usr/src/lib/libmd/inc.flg	Mon Oct  7 19:17:16 2013
+++ new/usr/src/lib/libmd/inc.flg	Mon Oct  7 19:17:16 2013
@@ -23,9 +23,11 @@
 # Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-#ident	"%Z%%M%	%I%	%E% SMI"
+# Copyright 2013 Saso Kiselkov.  All rights reserved.
 
+find_files "s.*" usr/src/common/crypto/edonr
 find_files "s.*" usr/src/common/crypto/md4
 find_files "s.*" usr/src/common/crypto/md5
 find_files "s.*" usr/src/common/crypto/sha1
 find_files "s.*" usr/src/common/crypto/sha2
+find_files "s.*" usr/src/common/crypto/skein
--- old/usr/src/lib/libmd/sparc/Makefile	Mon Oct  7 19:17:16 2013
+++ new/usr/src/lib/libmd/sparc/Makefile	Mon Oct  7 19:17:16 2013
@@ -20,12 +20,13 @@
 #
 #
 # Copyright (c) 2006, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2013 Saso Kiselkov. All rights reserved.
 #
 
 LIBRARY =	libmd.a
 VERS =		.1
 
-OBJECTS =	md4.o md5.o sha1.o sha2.o
+OBJECTS =	edonr.o md4.o md5.o sha1.o sha2.o skein.o skein_block.o
 
 include		$(SRC)/lib/Makefile.lib
 include		$(SRC)/lib/Makefile.rootfs
--- old/usr/src/lib/libmd/sparcv9/Makefile	Mon Oct  7 19:17:16 2013
+++ new/usr/src/lib/libmd/sparcv9/Makefile	Mon Oct  7 19:17:16 2013
@@ -20,12 +20,13 @@
 #
 #
 # Copyright (c) 2006, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2013 Saso Kiselkov. All rights reserved.
 #
 
 LIBRARY =	libmd.a
 VERS =		.1
 
-OBJECTS =	md4.o md5.o sha1.o sha2.o
+OBJECTS =	edonr.o md4.o md5.o sha1.o sha2.o skein.o skein_block.o
 
 include		$(SRC)/lib/Makefile.lib
 include		$(SRC)/lib/Makefile.rootfs
--- old/usr/src/lib/libzfs/common/libzfs_dataset.c	Mon Oct  7 19:17:16 2013
+++ new/usr/src/lib/libzfs/common/libzfs_dataset.c	Mon Oct  7 19:17:16 2013
@@ -1377,6 +1377,12 @@
 			    "property setting is not allowed on "
 			    "bootable datasets"));
 			(void) zfs_error(hdl, EZFS_NOTSUP, errbuf);
+		} else if (prop == ZFS_PROP_CHECKSUM ||
+		    prop == ZFS_PROP_DEDUP) {
+			(void) zfs_error_aux(hdl, dgettext(TEXT_DOMAIN,
+			    "property setting is not allowed on "
+			    "root pools"));
+			(void) zfs_error(hdl, EZFS_NOTSUP, errbuf);
 		} else {
 			(void) zfs_standard_error(hdl, err, errbuf);
 		}
--- old/usr/src/man/man1m/zfs.1m	Mon Oct  7 19:17:16 2013
+++ new/usr/src/man/man1m/zfs.1m	Mon Oct  7 19:17:16 2013
@@ -934,7 +934,7 @@
 .ne 2
 .na
 \fB\fBchecksum\fR=\fBon\fR | \fBoff\fR | \fBfletcher2\fR | \fBfletcher4\fR |
-\fBsha256\fR | \fBnoparity\fR \fR
+\fBsha256\fR | \fBnoparity\fR | \fBsha512\fR | \fBskein\fR | \fBedonr\fR\fR
 .ad
 .sp .6
 .RS 4n
@@ -947,6 +947,10 @@
 not be used by any other dataset. Disabling checksums is \fBNOT\fR a recommended
 practice.
 .sp
+The \fBsha512\fR, \fBskein\fR and \fBedonr\fR checksum algorithms require
+enabling the appropriate features on the pool. Please see
+\fBzpool-features(5)\fR for more information on these algorithms.
+.sp
 Changing this property affects only newly-written data.
 .RE
 
@@ -2862,7 +2866,7 @@
 times in the send stream will only be sent once.  The receiving system must
 also support this feature to recieve a deduplicated stream.  This flag can
 be used regardless of the dataset's \fBdedup\fR property, but performance
-will be much better if the filesystem uses a dedup-capable checksum (eg.
+will be much better if the filesystem uses a dedup-capable checksum (e.g.
 \fBsha256\fR).
 .RE
 
--- old/usr/src/pkg/manifests/system-header.mf	Mon Oct  7 19:17:17 2013
+++ new/usr/src/pkg/manifests/system-header.mf	Mon Oct  7 19:17:17 2013
@@ -23,6 +23,7 @@
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright (c) 2012 by Delphix. All rights reserved.
 # Copyright 2012 Nexenta Systems, Inc. All rights reserved.
+# Copyright 2013 Saso Kiselkov. All rights reserved.
 #
 
 set name=pkg.fmri value=pkg:/system/header@$(PKGVERS)
@@ -768,6 +769,7 @@
 file path=usr/include/siginfo.h
 file path=usr/include/signal.h
 file path=usr/include/sip.h
+file path=usr/include/skein.h
 file path=usr/include/smbios.h
 file path=usr/include/spawn.h
 $(i386_ONLY)file path=usr/include/stack_unwind.h
@@ -945,6 +947,7 @@
 file path=usr/include/sys/ecppreg.h
 file path=usr/include/sys/ecppsys.h
 file path=usr/include/sys/ecppvar.h
+file path=usr/include/sys/edonr.h
 file path=usr/include/sys/efi_partition.h
 file path=usr/include/sys/elf.h
 file path=usr/include/sys/elf_386.h
@@ -1435,6 +1438,7 @@
 file path=usr/include/sys/sid.h
 file path=usr/include/sys/siginfo.h
 file path=usr/include/sys/signal.h
+file path=usr/include/sys/skein.h
 file path=usr/include/sys/sleepq.h
 file path=usr/include/sys/smbios.h
 file path=usr/include/sys/smbios_impl.h
--- old/usr/src/pkg/manifests/system-kernel.mf	Mon Oct  7 19:17:17 2013
+++ new/usr/src/pkg/manifests/system-kernel.mf	Mon Oct  7 19:17:17 2013
@@ -21,6 +21,7 @@
 
 #
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2013 Saso Kiselkov. All rights reserved.
 #
 
 #
@@ -303,11 +304,13 @@
 file path=kernel/crypto/$(ARCH64)/blowfish group=sys mode=0755
 file path=kernel/crypto/$(ARCH64)/des group=sys mode=0755
 file path=kernel/crypto/$(ARCH64)/ecc group=sys mode=0755
+file path=kernel/crypto/$(ARCH64)/edonr group=sys mode=0755
 file path=kernel/crypto/$(ARCH64)/md4 group=sys mode=0755
 file path=kernel/crypto/$(ARCH64)/md5 group=sys mode=0755
 file path=kernel/crypto/$(ARCH64)/rsa group=sys mode=0755
 file path=kernel/crypto/$(ARCH64)/sha1 group=sys mode=0755
 file path=kernel/crypto/$(ARCH64)/sha2 group=sys mode=0755
+file path=kernel/crypto/$(ARCH64)/skein group=sys mode=0755
 file path=kernel/crypto/$(ARCH64)/swrand group=sys mode=0755
 $(i386_ONLY)file path=kernel/crypto/aes group=sys mode=0755
 $(i386_ONLY)file path=kernel/crypto/arcfour group=sys mode=0755
@@ -314,11 +317,13 @@
 $(i386_ONLY)file path=kernel/crypto/blowfish group=sys mode=0755
 $(i386_ONLY)file path=kernel/crypto/des group=sys mode=0755
 $(i386_ONLY)file path=kernel/crypto/ecc group=sys mode=0755
+$(i386_ONLY)file path=kernel/crypto/edonr group=sys mode=0755
 $(i386_ONLY)file path=kernel/crypto/md4 group=sys mode=0755
 $(i386_ONLY)file path=kernel/crypto/md5 group=sys mode=0755
 $(i386_ONLY)file path=kernel/crypto/rsa group=sys mode=0755
 $(i386_ONLY)file path=kernel/crypto/sha1 group=sys mode=0755
 $(i386_ONLY)file path=kernel/crypto/sha2 group=sys mode=0755
+$(i386_ONLY)file path=kernel/crypto/skein group=sys mode=0755
 $(i386_ONLY)file path=kernel/crypto/swrand group=sys mode=0755
 $(sparc_ONLY)file path=kernel/dacf/$(ARCH64)/consconfig_dacf group=sys \
     mode=0755
@@ -817,6 +822,8 @@
 $(i386_ONLY)file path=usr/share/man/man7d/smbios.7d
 # Sadly vuid mouse support is in different packages on different platforms
 # While kstat(7D) is in SUNWcs, the structures are general
+hardlink path=kernel/misc/$(ARCH64)/edonr \
+    target=../../../kernel/crypto/$(ARCH64)/edonr
 hardlink path=kernel/misc/$(ARCH64)/md5 \
     target=../../../kernel/crypto/$(ARCH64)/md5
 hardlink path=kernel/misc/$(ARCH64)/sha1 \
@@ -823,9 +830,13 @@
     target=../../../kernel/crypto/$(ARCH64)/sha1
 hardlink path=kernel/misc/$(ARCH64)/sha2 \
     target=../../../kernel/crypto/$(ARCH64)/sha2
+hardlink path=kernel/misc/$(ARCH64)/skein \
+    target=../../../kernel/crypto/$(ARCH64)/skein
+$(i386_ONLY)hardlink path=kernel/misc/edonr target=../../kernel/crypto/edonr
 $(i386_ONLY)hardlink path=kernel/misc/md5 target=../../kernel/crypto/md5
 $(i386_ONLY)hardlink path=kernel/misc/sha1 target=../../kernel/crypto/sha1
 $(i386_ONLY)hardlink path=kernel/misc/sha2 target=../../kernel/crypto/sha2
+$(i386_ONLY)hardlink path=kernel/misc/skein target=../../kernel/crypto/skein
 hardlink path=kernel/socketmod/$(ARCH64)/icmp \
     target=../../../kernel/drv/$(ARCH64)/icmp
 hardlink path=kernel/socketmod/$(ARCH64)/rts \
--- old/usr/src/uts/common/Makefile.files	Mon Oct  7 19:17:17 2013
+++ new/usr/src/uts/common/Makefile.files	Mon Oct  7 19:17:17 2013
@@ -507,6 +507,10 @@
 
 SHA2_OBJS +=	sha2.o sha2_mod.o
 
+SKEIN_OBJS +=	skein.o skein_block.o skein_mod.o
+
+EDONR_OBJS +=	edonr.o edonr_mod.o
+
 IPGPC_OBJS +=   classifierddi.o classifier.o filters.o trie.o table.o \
 		ba_table.o
 
@@ -1364,6 +1368,8 @@
 	rrwlock.o		\
 	sa.o			\
 	sha256.o		\
+	edonr_zfs.o		\
+	skein_zfs.o		\
 	spa.o			\
 	spa_config.o		\
 	spa_errlog.o		\
--- old/usr/src/uts/common/Makefile.rules	Mon Oct  7 19:17:18 2013
+++ new/usr/src/uts/common/Makefile.rules	Mon Oct  7 19:17:18 2013
@@ -22,6 +22,7 @@
 #
 # Copyright (c) 1991, 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright (c) 2012 Nexenta Systems, Inc. All rights reserved.
+# Copyright 2013 Saso Kiselkov. All rights reserved.
 #
 
 #
@@ -1520,6 +1521,10 @@
 	$(COMPILE.c) -o $@ $<
 	$(CTFCONVERT_O)
 
+$(OBJS_DIR)/%.o:		$(COMMONBASE)/crypto/edonr/%.c
+	$(COMPILE.c) -o $@ $<
+	$(CTFCONVERT_O)
+
 $(OBJS_DIR)/%.o:		$(COMMONBASE)/crypto/sha1/%.c
 	$(COMPILE.c) -o $@ $<
 	$(CTFCONVERT_O)
@@ -1528,6 +1533,10 @@
 	$(COMPILE.c) -o $@ $<
 	$(CTFCONVERT_O)
 
+$(OBJS_DIR)/%.o:		$(COMMONBASE)/crypto/skein/%.c
+	$(COMPILE.c) -o $@ $<
+	$(CTFCONVERT_O)
+
 $(OBJS_DIR)/%.o:		$(UTSBASE)/common/syscall/%.c
 	$(COMPILE.c) -o $@ $<
 	$(CTFCONVERT_O)
@@ -2652,6 +2661,9 @@
 $(LINTS_DIR)/%.ln:		$(UTSBASE)/common/rpc/sec_gss/%.c
 	@($(LHEAD) $(LINT.c) $< $(LTAIL))
 
+$(LINTS_DIR)/%.ln:		$(COMMONBASE)/crypto/edonr/%.c
+	@($(LHEAD) $(LINT.c) $< $(LTAIL))
+
 $(LINTS_DIR)/%.ln:		$(COMMONBASE)/crypto/sha1/%.c
 	@($(LHEAD) $(LINT.c) $< $(LTAIL))
 
@@ -2658,6 +2670,9 @@
 $(LINTS_DIR)/%.ln:		$(COMMONBASE)/crypto/sha2/%.c
 	@($(LHEAD) $(LINT.c) $< $(LTAIL))
 
+$(LINTS_DIR)/%.ln:		$(COMMONBASE)/crypto/skein/%.c
+	@($(LHEAD) $(LINT.c) $< $(LTAIL))
+
 $(LINTS_DIR)/%.ln:		$(UTSBASE)/common/syscall/%.c
 	@($(LHEAD) $(LINT.c) $< $(LTAIL))
 
--- /dev/null	Mon Oct  7 19:17:18 2013
+++ new/usr/src/uts/common/crypto/io/edonr_mod.c	Mon Oct  7 19:17:18 2013
@@ -0,0 +1,63 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://opensource.org/licenses/CDDL-1.0.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2013 Saso Kiselkov. All rights reserved.
+ */
+
+#include <sys/modctl.h>
+#include <sys/crypto/common.h>
+#include <sys/crypto/spi.h>
+#include <sys/sysmacros.h>
+#include <sys/systm.h>
+#include <sys/edonr.h>
+
+/*
+ * Unlike sha2 or skein, we won't expose edonr via the Kernel Cryptographic
+ * Framework (KCF), because Edon-R is *NOT* suitable for general-purpose
+ * cryptographic use. Users of Edon-R must interface directly to this module.
+ */
+
+static struct modlmisc modlmisc = {
+	&mod_miscops,
+	"Edon-R Message-Digest Algorithm"
+};
+
+static struct modlinkage modlinkage = {
+	MODREV_1, &modlmisc, NULL
+};
+
+int
+_init(void)
+{
+	int error;
+
+	if ((error = mod_install(&modlinkage)) != 0)
+		return (error);
+
+	return (0);
+}
+
+int
+_info(struct modinfo *modinfop)
+{
+	return (mod_info(&modlinkage, modinfop));
+}
